ALTER TABLE IDN_SAML2_ASSERTION_STORE ADD ASSERTION VARBINARY(MAX);

ALTER TABLE IDN_OAUTH_CONSUMER_APPS ALTER COLUMN CALLBACK_URL VARCHAR(2048);

ALTER TABLE IDN_OAUTH1A_REQUEST_TOKEN ALTER COLUMN CALLBACK_URL VARCHAR(2048);

ALTER TABLE IDN_OAUTH2_AUTHORIZATION_CODE ALTER COLUMN CALLBACK_URL VARCHAR(2048);

IF NOT  EXISTS (SELECT * FROM SYS.OBJECTS WHERE OBJECT_ID = OBJECT_ID(N'[DBO].[IDN_AUTH_USER]') AND TYPE IN (N'U'))
CREATE TABLE IDN_AUTH_USER (
	USER_ID VARCHAR(255) NOT NULL,
	USER_NAME VARCHAR(255) NOT NULL,
	TENANT_ID INTEGER NOT NULL,
	DOMAIN_NAME VARCHAR(255) NOT NULL,
	IDP_ID INTEGER NOT NULL,
	PRIMARY KEY (USER_ID),
	CONSTRAINT USER_STORE_CONSTRAINT UNIQUE (USER_NAME, TENANT_ID, DOMAIN_NAME, IDP_ID));

IF NOT  EXISTS (SELECT * FROM SYS.OBJECTS WHERE OBJECT_ID = OBJECT_ID(N'[DBO].[IDN_AUTH_USER_SESSION_MAPPING]') AND TYPE IN (N'U'))
CREATE TABLE IDN_AUTH_USER_SESSION_MAPPING (
	USER_ID VARCHAR(255) NOT NULL,
	SESSION_ID VARCHAR(255) NOT NULL,
	CONSTRAINT USER_SESSION_STORE_CONSTRAINT UNIQUE (USER_ID, SESSION_ID));

IF NOT EXISTS (SELECT * FROM SYS.indexes WHERE name = 'IDX_USER_ID' and object_id = OBJECT_ID('IDN_AUTH_USER_SESSION_MAPPING'))
CREATE INDEX IDX_USER_ID ON IDN_AUTH_USER_SESSION_MAPPING (USER_ID);

IF NOT EXISTS (SELECT * FROM SYS.indexes WHERE name = 'IDX_SESSION_ID' and object_id = OBJECT_ID('IDN_AUTH_USER_SESSION_MAPPING'))
CREATE INDEX IDX_SESSION_ID ON IDN_AUTH_USER_SESSION_MAPPING (SESSION_ID);

IF NOT EXISTS (SELECT * FROM SYS.indexes WHERE name = 'IDX_OCA_UM_TID_UD_APN' and object_id = OBJECT_ID('IDN_OAUTH_CONSUMER_APPS'))
CREATE INDEX IDX_OCA_UM_TID_UD_APN ON IDN_OAUTH_CONSUMER_APPS(USERNAME,TENANT_ID,USER_DOMAIN, APP_NAME);

IF NOT EXISTS (SELECT * FROM SYS.indexes WHERE name = 'IDX_SPI_APP' and object_id = OBJECT_ID('SP_INBOUND_AUTH'))
CREATE INDEX IDX_SPI_APP ON SP_INBOUND_AUTH(APP_ID);

IF NOT EXISTS (SELECT * FROM SYS.indexes WHERE name = 'IDX_IOP_TID_CK' and object_id = OBJECT_ID('IDN_OIDC_PROPERTY'))
CREATE INDEX IDX_IOP_TID_CK ON IDN_OIDC_PROPERTY(TENANT_ID,CONSUMER_KEY);
